#region usings
using System;
using System.ComponentModel.Composition;

using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VColor;
using VVVV.Utils.VMath;

using VVVV.Core.Logging;
using VVVV.Core;
using VVVV.Core.Collections;
using VVVV.PluginInterfaces.V2.Graph;

using System.Collections.Generic;
using VVVV.Utils.Linq;
using VVVV.Utils.Network;

using System.IO;
using System.Linq;
using System.Reflection;


using System.Text.RegularExpressions;
using VVVV.Hosting.Graph;

using System.Net;
using System.Net.Sockets;
using System.Text;

using System.Threading;

using System.Drawing;
using System.Runtime.InteropServices;


#endregion usings

namespace VVVV.Nodes
{
    #region PluginInfo
    [PluginInfo(Name = "CollaborationMode", AutoEvaluate = true, Category = "fun", Help = "", Tags = "")]
    #endregion PluginInfo
    public class CollaborationMode : IPluginEvaluate, INodeListener, IDisposable // IPinListener
    {
        #region fields & pins
        [Input("IsServer", DefaultBoolean = false, IsSingle = true, Order = 0)]
        public IDiffSpread<bool> FInputIsServer;

        [Input("IP", DefaultString = "192.168.1.38", IsSingle = true, Order = 1)]
        public IDiffSpread<string> FInputIP;

        [Input("Port", DefaultValue = 11000, IsSingle = true, Order = 2)]
        public IDiffSpread<int> FInputPort;

        [Input("Run", IsToggle = true, IsSingle = true, Order = 3)]
        public IDiffSpread<bool> FInputRun;

        [Output("Connected", IsSingle = true)]
        public ISpread<bool> FOutputConnected;

        [Import()]
        public ILogger FLogger;

        [Import()]
        public IHDEHost FHDEHost;
        #endregion fields & pins



        public class Task
        {
            public int type;
            public object obj;

            public Task(int type, object obj)
            {
                this.type = type;
                this.obj = obj;
            }
        }

        // TODO:
        // maybe make socket in non-blockin mode
        // use VVVV.Utils.Win32.User32


        [Flags()]
        public enum WindowStylesEx : uint
        {
            WS_EX_CLIENTEDGE = 0x00000200,
            WS_EX_TRANSPARENT = 0x00000020,
        }

        [Flags()]
        public enum WindowStyles : uint
        {
            WS_CHILD = 0x40000000,
            WS_CLIPSIBLINGS = 0x4000000,
            WS_VISIBLE = 0x10000000,
            SS_BITMAP = 0x0000000E,
        }

        [DllImport("user32.dll", SetLastError = true)]
        public static extern IntPtr CreateWindowEx(
           WindowStylesEx dwExStyle,
           string lpClassName,
           string lpWindowName,
           WindowStyles dwStyle,
           int x,
           int y,
           int nWidth,
           int nHeight,
           IntPtr hWndParent,
           IntPtr hMenu,
           IntPtr hInstance,
           IntPtr lpParam);

        [DllImport("user32.dll", SetLastError = true)]
        static extern int GetWindowLong(IntPtr hWnd, int nIndex);

        [DllImport("user32.dll")]
        static extern bool InvalidateRect(IntPtr hWnd, IntPtr lpRect, bool bErase);



        [DllImport("user32.dll", SetLastError = true, CharSet = CharSet.Auto)]
        static extern IntPtr LoadImage(IntPtr hinst, string lpszName, uint uType,
           int cxDesired, int cyDesired, uint fuLoad);


        [DllImport("user32.dll")]
        public static extern int SendMessage(IntPtr hWnd, int msg, uint wParam,
        IntPtr lParam);

        [DllImport("user32.dll", SetLastError = true)]
        static extern IntPtr FindWindowEx(IntPtr hwndParent, IntPtr hwndChildAfter, string lpszClass, string lpszWindow);

        [DllImport("user32.dll")]
        static extern int SetWindowRgn(IntPtr hWnd, IntPtr hRgn, bool bRedraw);

        [DllImport("gdi32.dll")]
        static extern IntPtr CreateRectRgn(int nLeftRect, int nTopRect, int nRightRect, int nBottomRect);

        [DllImport("gdi32.dll")]
        static extern int CombineRgn(IntPtr hrgnDest, IntPtr hrgnSrc1,
           IntPtr hrgnSrc2, int fnCombineMode);


        [Serializable, StructLayout(LayoutKind.Sequential)]
        struct SCROLLINFO
        {
            public uint cbSize;
            public uint fMask;
            public int nMin;
            public int nMax;
            public uint nPage;
            public int nPos;
            public int nTrackPos;
        }
        public enum ScrollInfoMask : uint
        {
            SIF_RANGE = 0x1,
            SIF_PAGE = 0x2,
            SIF_POS = 0x4,
            SIF_DISABLENOSCROLL = 0x8,
            SIF_TRACKPOS = 0x10,
            SIF_ALL = (SIF_RANGE | SIF_PAGE | SIF_POS | SIF_TRACKPOS),
        }


        [DllImport("user32.dll")]
        [return: MarshalAs(UnmanagedType.Bool)]
        private static extern bool GetScrollInfo(IntPtr hwnd, int fnBar, ref SCROLLINFO lpsi);


        [DllImport("user32.dll", SetLastError = true)]
        [return: MarshalAs(UnmanagedType.Bool)]
        private static extern bool SetWindowPos(IntPtr hWnd, IntPtr hWndInsertAfter, int x, int y, int cx, int cy, uint uFlags);



        [DllImport("user32.dll")]
        static extern bool ClientToScreen(IntPtr hWnd, ref Point lpPoint);
        [DllImport("user32.dll")]
        static extern bool ScreenToClient(IntPtr hWnd, ref Point lpPoint);
        [DllImport("user32.dll")]
        public static extern bool GetCursorPos(out Point lpPoint);

        [DllImport("user32.dll", CharSet = CharSet.Unicode, SetLastError = true)]
        [return: MarshalAs(UnmanagedType.Bool)]
        static extern bool DestroyWindow(IntPtr hwnd);

        IntPtr hWndCursor;
        IntPtr hWndPatch;



        //-----------------------------------------------------------------------------------------------------

        const int mouseSize = 32;
        int _mouseX = -mouseSize, _mouseY = -mouseSize;

        INode2[] selectedNodes = null;
        bool init;
        bool isRunXML;
        string PluginNodeName;
        string xmlToSend = null;
        int lastId = 0;

        List<int> idList = new List<int>();
        Dictionary<string, string> idConverter = new Dictionary<string, string>();


        public class TcpSyncSocket : IDisposable
        {
            // Incoming data from the client.
            public string dataRead = null;
            public string dataWrite = null;
            public bool isRead;
            public bool isConnected;

            private bool isServer;
            private string ip = "127.0.0.1";
            private int port = 11000;

            public bool reconnect = true;

            Socket socket = null;
            Socket handler = null;



            public void Start(bool isServer = true, string ip = "127.0.0.1", int port = 11000)
            {
                this.isServer = isServer;
                this.ip = ip;
                this.port = port;

                // Data buffer for incoming data.

                reconnect = true;


                Connect();

            }

            private void Connect()
            {
                byte[] bytes = new byte[1024 * 1024];

                dataRead = null;
                dataWrite = null;

                isRead = isServer;

                IPEndPoint ipEndPoint = new IPEndPoint(IPAddress.Parse(ip), port);
                socket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
                socket.NoDelay = true;

                try
                {
                    if (isServer)
                    {
                        socket.Bind(ipEndPoint);
                        socket.Listen(10);
                        while (true)
                        {
                            //  System.Windows.Forms.MessageBox.Show("WAIT");
                            handler = socket.Accept();
                            isConnected = true;

                            while (true)
                            {
                                if (isRead)
                                {
                                    int bytesRec = handler.Receive(bytes);
                                    dataRead = Encoding.Unicode.GetString(bytes, 0, bytesRec);


                                    isRead = false;
                                }
                                else if (dataWrite != null)
                                {
                                    int bytesSent = handler.Send(Encoding.Unicode.GetBytes(dataWrite));
                                    dataWrite = null;

                                    isRead = true;
                                }
                                Thread.Sleep(20);
                            }


                        }

                    }
                    else
                    {
                        socket.Connect(ipEndPoint);
                        isConnected = true;
                        while (true)
                        {
                            if (isRead)
                            {
                                int bytesRec = socket.Receive(bytes);
                                dataRead = Encoding.Unicode.GetString(bytes, 0, bytesRec);

                                isRead = false;
                            }
                            else if (dataWrite != null)
                            {
                                int bytesSent = socket.Send(Encoding.Unicode.GetBytes(dataWrite));
                                dataWrite = null;

                                isRead = true;
                            }
                            Thread.Sleep(20);
                        }
                    }

                }
                catch (Exception)
                {
                    Stop(reconnect);
                    if (reconnect)
                    {
                        Thread.Sleep(500);
                        Connect();
                    }
                }

            }

            public void Stop(bool reconnect = false)
            {
                this.reconnect = reconnect;

                isConnected = false;
                if (handler != null)
                {
                    handler.Close();
                }
                if (socket != null)
                {
                    socket.Close();
                }
            }

            public void Dispose()
            {
                Stop();
            }


        }

        List<Task> tasks = new List<Task>();
        TcpSyncSocket socket;
        string LocalPath;

        INode2 patchNode;

        [ImportingConstructor]
        public CollaborationMode(IHDEHost hdeHost, INode node)
        {
            LocalPath = Path.GetDirectoryName(node.GetNodeInfo().Filename);

            socket = new TcpSyncSocket();

            System.Reflection.MemberInfo info = typeof(CollaborationMode);
            object[] attributes = info.GetCustomAttributes(true);
            for (int i = 0; i < attributes.Length; i++)
            {
                if (attributes[i] is PluginInfoAttribute)
                {
                    PluginNodeName = (attributes[i] as PluginInfoAttribute).Systemname;
                }
            }

            FHDEHost = hdeHost;
            FHDEHost.NodeSelectionChanged += FHDEHost_NodeSelectionChanged;

            patchNode = FHDEHost.GetNodeFromPath(node.ParentNode.GetNodePath(false));
        }

        private void StartSocket(object obj)
        {
            socket.Start(FInputIsServer[0], FInputIP[0], FInputPort[0]);
        }



        public void runXML(string xml)
        {
            isRunXML = true;

            List<int> id = new List<int>();
            foreach (Match m in Regex.Matches(xml, "id=\"(\\d+)\"", RegexOptions.Multiline))
            {
                id.Add(int.Parse(m.Groups[1].Value));
            }
            id = id.Distinct().ToList(); // unique id

            // replace id
            for (int i = 0; i < id.Count; i++)
            {
                if (!idList.Contains(id[i]))
                {
                    idList.Add(id[i]);
                    idConverter.Add("id=\"" + id[i] + "\"", "id=\"" + (lastId + 1) + "\"");
                    lastId += 1;
                }
            }



            if (idConverter.Count > 0)
            {
                xml = Regex.Replace(xml, string.Join("|", idConverter.Keys.Select(k => k.ToString()).ToArray()), m => idConverter[m.Value]);
            }
            if (xml != null) xml = xml.Replace("id=\"_", "id=\"");

            string[] tasks = xml.Split('\u0001');
            for (int i = 0; i < tasks.Count() - 1; i++)
            {
                xml = "<PATCH>" + tasks[i] + "</PATCH>";
                //        System.Windows.Forms.MessageBox.Show("RUN: " + xml);	
                FHDEHost.SendXMLSnippet(FHDEHost.ActivePatchWindow.Node.NodeInfo.Filename, xml, false);
            }

            isRunXML = false;
        }

        public void nodeAddListener(INode2 node)
        {
            (node as Node).BoundsChanged += OnBoundsChanged;

            node.InternalCOMInterf.AddListener(this);

            foreach (IPin2 pin in node.Pins)
            {
                pin.Changed += pin_Changed;
                pin.Connected += pin_Connected;
                pin.Disconnected += pin_Disconnected;
            }
        }

        public void nodeRemoveListener(INode2 node)
        {
            (node as Node).BoundsChanged -= OnBoundsChanged;

            node.InternalCOMInterf.RemoveListener(this);

            foreach (IPin2 pin in node.Pins)
            {
                pin.Changed -= pin_Changed;
                pin.Connected -= pin_Connected;
                pin.Disconnected -= pin_Disconnected;
            }
        }

        public string nodesAddToXML()
        {
            string xmlToSend = "";

            INode2[] _selectedNodes = selectedNodes;

            for (int i = 0; i < tasks.Count; i++)
            {
                if (tasks[i].type == 0)
                {
                    FHDEHost.SelectNodes(new INode2[] { tasks[i].obj as INode2 });

                        //System.Windows.Forms.MessageBox.Show("ADD:" + FHDEHost.GetXMLSnippetFromSelection());

					MatchCollection m = Regex.Matches(FHDEHost.GetXMLSnippetFromSelection(), "<PATCH>(.*?)</PATCH>", RegexOptions.Multiline);
                    xmlToSend += m[0].Groups[1].Value;
                    
                }
                else if (tasks[i].type == 1)
                    xmlToSend += tasks[i].obj as string;

                xmlToSend += '\u0001';
            }

            FHDEHost.SelectNodes(_selectedNodes);
            return xmlToSend;
        }





        public void AddedCB(INode internalChildNode)
        {
            INode2 node = FHDEHost.GetNodeFromPath(internalChildNode.GetNodePath(false));

            if (!node.Name.Equals(PluginNodeName) && !node.NodeInfo.Category.Equals("Editor"))
            {
                nodeAddListener(node);

                if (!isRunXML) { tasks.Add(new Task(0, node)); }
            }

            FLogger.Log(LogType.Debug, "AddedCB: " + node.ID);

            if (node.ID > lastId) lastId = node.ID;
        }
        public void RemovedCB(INode internalChildNode)
        {
            try
            {
                INode2 node = FHDEHost.GetNodeFromPath(internalChildNode.GetNodePath(false));
                if (!node.Name.Equals(PluginNodeName) && !node.NodeInfo.Category.Equals("Editor"))
                {
                    nodeRemoveListener(node);

                    if (!isRunXML) tasks.Add(new Task(1, "<NODE id=\"" + node.ID + "\" deleteme=\"true\"></NODE>"));
                }

                FLogger.Log(LogType.Debug, "RemovedCB");
            }
            catch
            {

            }
        }


        public void PinAddedCB(IPin internalPin)
        {
            FLogger.Log(LogType.Debug, "PinAddedCB");
        }
        public void PinRemovedCB(IPin internalPin)
        {
            FLogger.Log(LogType.Debug, "PinRemovedCB");
        }
        public void LabelChangedCB()
        {
            FLogger.Log(LogType.Debug, "LabelChangedCB");
        }
        public void StatusChangedCB()
        {
            FLogger.Log(LogType.Debug, "StatusChangedCB");
        }
        public void InnerStatusChangedCB()
        {
            FLogger.Log(LogType.Debug, "InnerStatusChangedCB");
        }
        public void BoundsChangedCB(BoundsType boundsType)
        {
            FLogger.Log(LogType.Debug, "BoundsChangedCB " + boundsType.ToString());
        }


        public void OnBoundsChanged(object sender, BoundsChangedEventArgs a)
        {
            INode2 node = sender as INode2;

            if (a.BoundsType == BoundsType.Node && !node.Name.Equals(PluginNodeName))
            {
                if (!isRunXML) tasks.Add(new Task(0, node));

            }
            FLogger.Log(LogType.Debug, "OnBoundsChanged " + node.Name);
        }



        void node_StatusChanged(object sender, System.EventArgs e)
        {
            FLogger.Log(LogType.Debug, "node_StatusChanged ");
        }

        void pin_Connected(object sender, PinConnectionEventArgs args)
        {
            IPin2 pin = sender as IPin2;
        	// pin.ParentNodeByPatch(patchNode) != null && 
            if (!pin.ParentNode.NodeInfo.Systemname.Equals(PluginNodeName) && !args.OtherPin.ParentNode.GetNodeInfo().Systemname.Equals(PluginNodeName))
            {
                INode2 node2 = FHDEHost.GetNodeFromPath(args.OtherPin.ParentNode.GetNodePath(false));
                if (!isRunXML) { tasks.Add(new Task(0, pin.ParentNode)); }// updatedNodes.Add(node2); } 
            }

            FLogger.Log(LogType.Debug, "pin_Connected " + pin.ParentNode.NodeInfo.Name + " (" + pin.ParentNode.ID + ")" + ", " + sender.GetType().ToString() + " | " + args.OtherPin.ParentNode.GetNodeInfo().Name + " (" + args.OtherPin.ParentNode.GetID() + ")");// pin.ParentNode.GetID());
        }
        void pin_Disconnected(object sender, PinConnectionEventArgs args)
        {
            IPin2 pin = sender as IPin2;
            if (!pin.ParentNode.NodeInfo.Systemname.Equals(PluginNodeName) && !args.OtherPin.ParentNode.GetNodeInfo().Systemname.Equals(PluginNodeName))
            {
                INode2 node2 = FHDEHost.GetNodeFromPath(args.OtherPin.ParentNode.GetNodePath(false));
                if (!isRunXML)
                    tasks.Add(new Task(1, "<LINK srcnodeid=\"" + pin.ParentNode.ID + "\" srcpinname=\"" + pin.Name + "\" dstnodeid=\"" + node2.ID + "\" dstpinname=\"" + args.OtherPin.Name + "\" deleteme=\"true\"></LINK>"));
            }

            FLogger.Log(LogType.Debug, "pin_Disconnected");
        }
        void pin_Changed(object sender, System.EventArgs e)
        {
            IPin2 pin = sender as IPin2;
            if (!pin.ParentNode.NodeInfo.Systemname.Equals(PluginNodeName))
            {
                if (!isRunXML) { tasks.Add(new Task(0, pin.ParentNode)); }
            }
            FLogger.Log(LogType.Debug, "pin_Changed " + pin.ParentNode.Name);
        }
        void pin_Added(IViewableCollection<IPin2> collection, IPin2 item)
        {
            FLogger.Log(LogType.Debug, "pin_Added");
        }

        void node_OrderChanged(IViewableCollection<INode2> list)
        {
            FLogger.Log(LogType.Debug, "node_OrderChanged");
        }
        void node_Added(IViewableCollection<INode2> collection, INode2 item)
        {
            FLogger.Log(LogType.Debug, "node_Added");
        }
        void node_Removed(IViewableCollection<INode2> collection, INode2 item)
        {
            FLogger.Log(LogType.Debug, "node_Removed");
        }

        void node_Updated(IViewableCollection collection)
        {
            FLogger.Log(LogType.Debug, "node_Updated");
        }


        void HandleAfterComponentModeChange(object sender, ComponentModeEventArgs args)
        {
            FLogger.Log(LogType.Debug, "HandleAfterComponentModeChange!!!");
        }


        //called when data for any output pin is requested
        public void Evaluate(int SpreadMax)
        {

            if (FInputRun.IsChanged)
            {
                socket.Stop();
                if (FInputRun[0] == true) 
            	{ 
            		tasks.Clear(); 
            		ThreadPool.QueueUserWorkItem(new WaitCallback(StartSocket), null);
            	}
            }

            if (init == false)
            {
                init = true;
                foreach (INode2 node in FHDEHost.RootNode.AsDepthFirstEnumerable())
                {
                    if (!node.NodeInfo.Name.Equals(PluginNodeName) && !node.NodeInfo.Category.Equals("Editor"))
                    {
                        FLogger.Log(LogType.Debug, "node.NodeInfo.UserData: " + node.Name + " | " + node.NodeInfo.Name + " | " + node.GetNodePath(false));
                        nodeAddListener(node);
                    }
                    if (node.ID > lastId) lastId = node.ID;
                }

                // ----------mouse
                hWndPatch = FHDEHost.ActivePatchWindow.Handle;
                if (hWndPatch.ToInt64() != 0)
                {
                    hWndPatch = FindWindowEx(hWndPatch, IntPtr.Zero, "TPanel", null);
                    if (hWndPatch.ToInt64() != 0)
                    {
                        hWndPatch = FindWindowEx(hWndPatch, IntPtr.Zero, "AfxOleControl42", null);

                        hWndCursor = CreateWindowEx(
                        WindowStylesEx.WS_EX_TRANSPARENT, "Static", "",
                        WindowStyles.SS_BITMAP | WindowStyles.WS_CLIPSIBLINGS | WindowStyles.WS_CHILD | WindowStyles.WS_VISIBLE,
                        0, 0, 40, 40, hWndPatch, IntPtr.Zero, // window menu handle
                        (IntPtr)GetWindowLong(FHDEHost.ActivePatchWindow.Handle, 0),
                        IntPtr.Zero);

                        uint LR_LOADFROMFILE = 0x0010;
                        int STM_SETIMAGE = 0x172;
                        uint IMAGE_BITMAP = 0x0;



                        IntPtr handle = LoadImage(IntPtr.Zero, LocalPath + "\\assets\\idc_arrow.bmp", IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);//,0,0,0,0);
                        SendMessage(hWndCursor, STM_SETIMAGE, IMAGE_BITMAP, handle);
                        Bitmap image1 = (Bitmap)Image.FromFile(LocalPath + "\\assets\\idc_arrow_mask.png", true);

                        IntPtr hRgn = CreateRectRgn(0, 0, 0, 0);
                        FLogger.Log(LogType.Debug, "create virtual cursor....");
                        for (int y = 0; y < image1.Height; y++)
                        {
                            int _x = 0;
                            bool f = false;
                            for (int x = 0; x < image1.Width; x++)
                            {
                                Color col = image1.GetPixel(x, y);
                                if (col.A == 0 && f)
                                {
                                    IntPtr hRgn2 = CreateRectRgn(_x, y, x, y + 1);
                                    CombineRgn(hRgn, hRgn, hRgn2, 2); // 2 - RGN_OR
                                    f = false;
                                }
                                else if (col.A != 0 && !f)
                                {
                                    f = true;
                                    _x = x;
                                }
                            }
                        }
                        SetWindowRgn(hWndCursor, hRgn, true);

                    }

                }

            }


            int mouseX, mouseY;
            // --------------
            {
                SCROLLINFO si;
                si = new SCROLLINFO();
                si.cbSize = (uint)Marshal.SizeOf(si);
                si.fMask = (uint)ScrollInfoMask.SIF_TRACKPOS;
                GetScrollInfo(hWndPatch, 0, ref si);
                int iWidth = si.nMax - si.nMin;
                int nX = si.nTrackPos;

                GetScrollInfo(hWndPatch, 1, ref si);
                int nY = si.nTrackPos;

                Point lpPoint;
                GetCursorPos(out lpPoint);
                ScreenToClient(hWndPatch, ref lpPoint);

                SetWindowPos(hWndCursor, IntPtr.Zero, _mouseX - nX, _mouseY - nY, 32, 32, 0);
                InvalidateRect(hWndCursor, IntPtr.Zero, true);

                mouseX = lpPoint.X + nX;
                mouseY = lpPoint.Y + nY;

            }

            // -----------



            if (socket.isConnected)
            {
                if (!socket.isRead && socket.dataWrite == null) // & ready for send
                {
                    xmlToSend = "";
                    if (tasks.Count > 0)
                    {
                        xmlToSend = nodesAddToXML();
                        if (idConverter.Count > 0)
                            xmlToSend = Regex.Replace(xmlToSend, string.Join("|", idConverter.Values.Select(k => k.ToString()).ToArray()), m => idConverter.FirstOrDefault(x => x.Value == m.Value).Key.Replace("id=\"", "id=\"_"));

                        //System.Windows.Forms.MessageBox.Show("SEND:" + xmlToSend);

                        tasks.Clear();
                    }
                    xmlToSend = string.Join(",", mouseX, mouseY, xmlToSend);

                    socket.dataWrite = xmlToSend;
                }

                if (socket.dataRead != null) // & ready for send
                {
                    //System.Windows.Forms.MessageBox.Show("READ:" + socket.dataRead);
                    string[] arr = socket.dataRead.Split(new Char[] { ',' }, 3);
                    if (arr.Count() == 3)
                    {
                        _mouseX = int.Parse(arr[0]);
                        _mouseY = int.Parse(arr[1]);
                        if (arr[2] != null)
                        {
                            runXML(arr[2]);
                        }
                    }
                    socket.dataRead = null;
                }
            }
            else
            {
                //tasks.Clear(); // don't save history when disconnect
                _mouseX = -mouseSize;
                _mouseY = -mouseSize;
            }

            FOutputConnected[0] = socket.isConnected;

        }

        void FHDEHost_NodeSelectionChanged(object sender, NodeSelectionEventArgs args)
        {
            selectedNodes = args.Nodes;
        }


        public void Dispose()
        {
            DestroyWindow(hWndCursor);

            socket.Stop();

            FLogger.Log(LogType.Debug, "Dispose!");
            FHDEHost.NodeSelectionChanged -= FHDEHost_NodeSelectionChanged;

            foreach (INode2 node in FHDEHost.RootNode.AsDepthFirstEnumerable())
            {
                nodeRemoveListener(node);
            }
        }

    }
}
